/*******************************************************************************
*
* test program to demonstrate debug tools
*
*******************************************************************************/

/*------------------------------------------------------------------------------
| standard header files 
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>

/*------------------------------------------------------------------------------
| local header files 
------------------------------------------------------------------------------*/
#include "subroutines.h"


/*******************************************************************************
* main routine 
*******************************************************************************/
int main(int argc,char *argv[])
{
  const int N = 10000;
  double *x = malloc(N * sizeof(double));
  double *y = malloc(N * sizeof(double));
  double *A = malloc(N * N * sizeof(double));

  /* zero vectors and matrices */
  zeroVector(x, N);
  zeroVector(y, N);
  zeroVector(A, N*N);

  /* init vectors and matrices */
  initMatrix(A, N);
  initVector(x, N);

  /* perform matrix vector multiplication y = A*x */
  matVecMul(1.0, 0.0, A, x, y, N);

  /* print norm of result */
  printf("|A.x| = %g\n", vecNorm(y, N));

  /* free arrays */
  free(x);
  free(y);
  free(A);
  
  return 0;
}
